diff -Naur linux-source-2.6.38.orig/fs/utimes.c linux-source-2.6.38.modif/fs/utimes.c
--- linux-source-2.6.38.orig/fs/utimes.c	2011-03-15 02:20:32.000000000 +0100
+++ linux-source-2.6.38.modif/fs/utimes.c	2011-12-16 16:09:49.000000000 +0100
@@ -28,6 +28,9 @@
 {
 	struct timespec tv[2];
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|utime");
+
 	if (times) {
 		if (get_user(tv[0].tv_sec, &times->actime) ||
 		    get_user(tv[1].tv_sec, &times->modtime))
@@ -176,6 +179,9 @@
 {
 	struct timespec tstimes[2];
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|utimensat");
+
 	if (utimes) {
 		if (copy_from_user(&tstimes, utimes, sizeof(tstimes)))
 			return -EFAULT;
@@ -195,6 +201,9 @@
 	struct timeval times[2];
 	struct timespec tstimes[2];
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|futimesat");
+
 	if (utimes) {
 		if (copy_from_user(&times, utimes, sizeof(times)))
 			return -EFAULT;
@@ -220,5 +229,8 @@
 SYSCALL_DEFINE2(utimes, char __user *, filename,
 		struct timeval __user *, utimes)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|utimes");
+
 	return sys_futimesat(AT_FDCWD, filename, utimes);
 }
diff -Naur linux-source-2.6.38.orig/fs/xattr.c linux-source-2.6.38.modif/fs/xattr.c
--- linux-source-2.6.38.orig/fs/xattr.c	2011-03-15 02:20:32.000000000 +0100
+++ linux-source-2.6.38.modif/fs/xattr.c	2011-12-16 13:47:10.000000000 +0100
@@ -283,6 +283,9 @@
 	struct path path;
 	int error;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setxattr");
+
 	error = user_path(pathname, &path);
 	if (error)
 		return error;
@@ -302,6 +305,9 @@
 	struct path path;
 	int error;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|lsetxattr");
+
 	error = user_lpath(pathname, &path);
 	if (error)
 		return error;
@@ -321,6 +327,9 @@
 	struct dentry *dentry;
 	int error = -EBADF;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|fsetxattr");
+
 	f = fget(fd);
 	if (!f)
 		return error;
@@ -379,6 +388,9 @@
 	struct path path;
 	ssize_t error;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|getxattr");
+
 	error = user_path(pathname, &path);
 	if (error)
 		return error;
@@ -393,6 +405,9 @@
 	struct path path;
 	ssize_t error;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|lgetxattr");
+
 	error = user_lpath(pathname, &path);
 	if (error)
 		return error;
@@ -407,6 +422,9 @@
 	struct file *f;
 	ssize_t error = -EBADF;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|fgetxattr");
+
 	f = fget(fd);
 	if (!f)
 		return error;
@@ -452,6 +470,9 @@
 	struct path path;
 	ssize_t error;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|listxattr");
+
 	error = user_path(pathname, &path);
 	if (error)
 		return error;
@@ -466,6 +487,9 @@
 	struct path path;
 	ssize_t error;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|llistxattr");
+
 	error = user_lpath(pathname, &path);
 	if (error)
 		return error;
@@ -479,6 +503,9 @@
 	struct file *f;
 	ssize_t error = -EBADF;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|flistxattr");
+
 	f = fget(fd);
 	if (!f)
 		return error;
@@ -512,6 +539,9 @@
 	struct path path;
 	int error;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|removexattr");
+
 	error = user_path(pathname, &path);
 	if (error)
 		return error;
@@ -530,6 +560,9 @@
 	struct path path;
 	int error;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|lremovexattr");
+
 	error = user_lpath(pathname, &path);
 	if (error)
 		return error;
@@ -548,6 +581,9 @@
 	struct dentry *dentry;
 	int error = -EBADF;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|fremovexattr");
+
 	f = fget(fd);
 	if (!f)
 		return error;
diff -Naur linux-source-2.6.38.orig/ipc/mqueue.c linux-source-2.6.38.modif/ipc/mqueue.c
--- linux-source-2.6.38.orig/ipc/mqueue.c	2011-03-15 02:20:32.000000000 +0100
+++ linux-source-2.6.38.modif/ipc/mqueue.c	2011-12-16 13:50:52.000000000 +0100
@@ -687,6 +687,9 @@
 	int fd, error;
 	struct ipc_namespace *ipc_ns = current->nsproxy->ipc_ns;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|mq_open");
+
 	if (u_attr && copy_from_user(&attr, u_attr, sizeof(struct mq_attr)))
 		return -EFAULT;
 
@@ -758,6 +761,9 @@
 	struct inode *inode = NULL;
 	struct ipc_namespace *ipc_ns = current->nsproxy->ipc_ns;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|mq_unlink");
+
 	name = getname(u_name);
 	if (IS_ERR(name))
 		return PTR_ERR(name);
@@ -858,6 +864,9 @@
 	struct timespec ts;
 	int ret;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|mq_timedsend");
+
 	if (u_abs_timeout) {
 		int res = prepare_timeout(u_abs_timeout, &expires, &ts);
 		if (res)
@@ -951,6 +960,9 @@
 	ktime_t expires, *timeout = NULL;
 	struct timespec ts;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|mq_timedreceive");
+
 	if (u_abs_timeout) {
 		int res = prepare_timeout(u_abs_timeout, &expires, &ts);
 		if (res)
@@ -1038,6 +1050,9 @@
 	struct mqueue_inode_info *info;
 	struct sk_buff *nc;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|mq_notify");
+
 	if (u_notification) {
 		if (copy_from_user(&notification, u_notification,
 					sizeof(struct sigevent)))
@@ -1168,6 +1183,9 @@
 	struct inode *inode;
 	struct mqueue_inode_info *info;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|mq_getsetattr");
+
 	if (u_mqstat != NULL) {
 		if (copy_from_user(&mqstat, u_mqstat, sizeof(struct mq_attr)))
 			return -EFAULT;
diff -Naur linux-source-2.6.38.orig/ipc/syscall.c linux-source-2.6.38.modif/ipc/syscall.c
--- linux-source-2.6.38.orig/ipc/syscall.c	2011-03-15 02:20:32.000000000 +0100
+++ linux-source-2.6.38.modif/ipc/syscall.c	2011-12-16 15:48:22.000000000 +0100
@@ -18,6 +18,9 @@
 {
 	int version, ret;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|ipc");
+
 	version = call >> 16; /* hack for backward compatibility */
 	call &= 0xffff;
 
diff -Naur linux-source-2.6.38.orig/kernel/acct.c linux-source-2.6.38.modif/kernel/acct.c
--- linux-source-2.6.38.orig/kernel/acct.c	2011-03-15 02:20:32.000000000 +0100
+++ linux-source-2.6.38.modif/kernel/acct.c	2011-12-16 13:55:27.000000000 +0100
@@ -275,6 +275,9 @@
 {
 	int error = 0;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|acct");
+
 	if (!capable(CAP_SYS_PACCT))
 		return -EPERM;
 
diff -Naur linux-source-2.6.38.orig/kernel/capability.c linux-source-2.6.38.modif/kernel/capability.c
--- linux-source-2.6.38.orig/kernel/capability.c	2011-03-15 02:20:32.000000000 +0100
+++ linux-source-2.6.38.modif/kernel/capability.c	2011-12-16 13:55:56.000000000 +0100
@@ -165,6 +165,9 @@
 	unsigned tocopy;
 	kernel_cap_t pE, pI, pP;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|capget");
+
 	ret = cap_validate_magic(header, &tocopy);
 	if ((dataptr == NULL) || (ret != 0))
 		return ((dataptr == NULL) && (ret == -EINVAL)) ? 0 : ret;
@@ -241,6 +244,9 @@
 	int ret;
 	pid_t pid;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|capset");
+
 	ret = cap_validate_magic(header, &tocopy);
 	if (ret != 0)
 		return ret;
diff -Naur linux-source-2.6.38.orig/kernel/exec_domain.c linux-source-2.6.38.modif/kernel/exec_domain.c
--- linux-source-2.6.38.orig/kernel/exec_domain.c	2011-03-15 02:20:32.000000000 +0100
+++ linux-source-2.6.38.modif/kernel/exec_domain.c	2011-12-16 13:56:42.000000000 +0100
@@ -183,6 +183,9 @@
 {
 	unsigned int old = current->personality;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|personality");
+
 	if (personality != 0xffffffff)
 		set_personality(personality);
 
diff -Naur linux-source-2.6.38.orig/kernel/exit.c linux-source-2.6.38.modif/kernel/exit.c
--- linux-source-2.6.38.orig/kernel/exit.c	2011-09-28 16:24:41.000000000 +0200
+++ linux-source-2.6.38.modif/kernel/exit.c	2011-12-16 14:01:57.000000000 +0100
@@ -1072,6 +1072,9 @@
 
 SYSCALL_DEFINE1(exit, int, error_code)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|exit");
+
 	do_exit((error_code&0xff)<<8);
 }
 
@@ -1113,6 +1116,9 @@
  */
 SYSCALL_DEFINE1(exit_group, int, error_code)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|exit_group");
+
 	do_group_exit((error_code & 0xff) << 8);
 	/* NOTREACHED */
 	return 0;
@@ -1686,6 +1692,9 @@
 	enum pid_type type;
 	long ret;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|waitid");
+
 	if (options & ~(WNOHANG|WNOWAIT|WEXITED|WSTOPPED|WCONTINUED))
 		return -EINVAL;
 	if (!(options & (WEXITED|WSTOPPED|WCONTINUED)))
@@ -1757,6 +1766,9 @@
 	enum pid_type type;
 	long ret;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|wait4");
+
 	if (options & ~(WNOHANG|WUNTRACED|WCONTINUED|
 			__WNOTHREAD|__WCLONE|__WALL))
 		return -EINVAL;
@@ -1796,6 +1808,9 @@
  */
 SYSCALL_DEFINE3(waitpid, pid_t, pid, int __user *, stat_addr, int, options)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|waitpid");
+
 	return sys_wait4(pid, stat_addr, options, NULL);
 }
 
diff -Naur linux-source-2.6.38.orig/kernel/fork.c linux-source-2.6.38.modif/kernel/fork.c
--- linux-source-2.6.38.orig/kernel/fork.c	2011-09-28 16:24:41.000000000 +0200
+++ linux-source-2.6.38.modif/kernel/fork.c	2011-12-16 14:03:12.000000000 +0100
@@ -943,6 +943,9 @@
 
 SYSCALL_DEFINE1(set_tid_address, int __user *, tidptr)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|set_tid_address");
+
 	current->clear_child_tid = tidptr;
 
 	return task_pid_vnr(current);
@@ -1634,6 +1637,9 @@
 	struct nsproxy *new_nsproxy = NULL;
 	int do_sysvsem = 0;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|unshare");
+
 	check_unshare_flags(&unshare_flags);
 
 	/* Return -EINVAL for all unsupported flags */
diff -Naur linux-source-2.6.38.orig/kernel/futex.c linux-source-2.6.38.modif/kernel/futex.c
--- linux-source-2.6.38.orig/kernel/futex.c	2011-09-28 16:24:41.000000000 +0200
+++ linux-source-2.6.38.modif/kernel/futex.c	2011-12-16 14:04:17.000000000 +0100
@@ -2379,6 +2379,9 @@
 SYSCALL_DEFINE2(set_robust_list, struct robust_list_head __user *, head,
 		size_t, len)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|set_robust_list");
+
 	if (!futex_cmpxchg_enabled)
 		return -ENOSYS;
 	/*
@@ -2406,6 +2409,9 @@
 	unsigned long ret;
 	const struct cred *cred = current_cred(), *pcred;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|get_robust_list");
+
 	if (!futex_cmpxchg_enabled)
 		return -ENOSYS;
 
@@ -2639,6 +2645,9 @@
 	u32 val2 = 0;
 	int cmd = op & FUTEX_CMD_MASK;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|futex");
+
 	if (utime && (cmd == FUTEX_WAIT || cmd == FUTEX_LOCK_PI ||
 		      cmd == FUTEX_WAIT_BITSET ||
 		      cmd == FUTEX_WAIT_REQUEUE_PI)) {
diff -Naur linux-source-2.6.38.orig/kernel/groups.c linux-source-2.6.38.modif/kernel/groups.c
--- linux-source-2.6.38.orig/kernel/groups.c	2011-03-15 02:20:32.000000000 +0100
+++ linux-source-2.6.38.modif/kernel/groups.c	2011-12-16 14:05:15.000000000 +0100
@@ -204,6 +204,9 @@
 	const struct cred *cred = current_cred();
 	int i;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|getgroups");
+
 	if (gidsetsize < 0)
 		return -EINVAL;
 
@@ -233,6 +236,9 @@
 	struct group_info *group_info;
 	int retval;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setgroups");
+
 	if (!capable(CAP_SETGID))
 		return -EPERM;
 	if ((unsigned)gidsetsize > NGROUPS_MAX)
diff -Naur linux-source-2.6.38.orig/kernel/hrtimer.c linux-source-2.6.38.modif/kernel/hrtimer.c
--- linux-source-2.6.38.orig/kernel/hrtimer.c	2011-03-15 02:20:32.000000000 +0100
+++ linux-source-2.6.38.modif/kernel/hrtimer.c	2011-12-16 15:30:00.000000000 +0100
@@ -1578,6 +1578,9 @@
 SYSCALL_DEFINE2(nanosleep, struct timespec __user *, rqtp,
 		struct timespec __user *, rmtp)
 {
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|nanosleep");
+
 	struct timespec tu;
 
 	if (copy_from_user(&tu, rqtp, sizeof(tu)))
diff -Naur linux-source-2.6.38.orig/kernel/ioport.c linux-source-2.6.38.modif/kernel/ioport.c
--- linux-source-2.6.38.orig/kernel/ioport.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-source-2.6.38.modif/kernel/ioport.c	2011-12-16 12:20:05.000000000 +0100
@@ -0,0 +1,129 @@
+/*
+ * This contains the io-permission bitmap code - written by obz, with changes
+ * by Linus. 32/64 bits code unification by Miguel Botón.
+ */
+
+#include <linux/sched.h>
+#include <linux/kernel.h>
+#include <linux/capability.h>
+#include <linux/errno.h>
+#include <linux/types.h>
+#include <linux/ioport.h>
+#include <linux/smp.h>
+#include <linux/stddef.h>
+#include <linux/slab.h>
+#include <linux/thread_info.h>
+#include <linux/syscalls.h>
+#include <asm/syscalls.h>
+
+/* Set EXTENT bits starting at BASE in BITMAP to value TURN_ON. */
+static void set_bitmap(unsigned long *bitmap, unsigned int base,
+		       unsigned int extent, int new_value)
+{
+	unsigned int i;
+
+	for (i = base; i < base + extent; i++) {
+		if (new_value)
+			__set_bit(i, bitmap);
+		else
+			__clear_bit(i, bitmap);
+	}
+}
+
+/*
+ * this changes the io permissions bitmap in the current task.
+ */
+asmlinkage long sys_ioperm(unsigned long from, unsigned long num, int turn_on)
+{
+	struct thread_struct *t = &current->thread;
+	struct tss_struct *tss;
+	unsigned int i, max_long, bytes, bytes_updated;
+
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|ioperm");
+
+	if ((from + num <= from) || (from + num > IO_BITMAP_BITS))
+		return -EINVAL;
+	if (turn_on && !capable(CAP_SYS_RAWIO))
+		return -EPERM;
+
+	/*
+	 * If it's the first ioperm() call in this thread's lifetime, set the
+	 * IO bitmap up. ioperm() is much less timing critical than clone(),
+	 * this is why we delay this operation until now:
+	 */
+	if (!t->io_bitmap_ptr) {
+		unsigned long *bitmap = kmalloc(IO_BITMAP_BYTES, GFP_KERNEL);
+
+		if (!bitmap)
+			return -ENOMEM;
+
+		memset(bitmap, 0xff, IO_BITMAP_BYTES);
+		t->io_bitmap_ptr = bitmap;
+		set_thread_flag(TIF_IO_BITMAP);
+	}
+
+	/*
+	 * do it in the per-thread copy and in the TSS ...
+	 *
+	 * Disable preemption via get_cpu() - we must not switch away
+	 * because the ->io_bitmap_max value must match the bitmap
+	 * contents:
+	 */
+	tss = &per_cpu(init_tss, get_cpu());
+
+	set_bitmap(t->io_bitmap_ptr, from, num, !turn_on);
+
+	/*
+	 * Search for a (possibly new) maximum. This is simple and stupid,
+	 * to keep it obviously correct:
+	 */
+	max_long = 0;
+	for (i = 0; i < IO_BITMAP_LONGS; i++)
+		if (t->io_bitmap_ptr[i] != ~0UL)
+			max_long = i;
+
+	bytes = (max_long + 1) * sizeof(unsigned long);
+	bytes_updated = max(bytes, t->io_bitmap_max);
+
+	t->io_bitmap_max = bytes;
+
+	/* Update the TSS: */
+	memcpy(tss->io_bitmap, t->io_bitmap_ptr, bytes_updated);
+
+	put_cpu();
+
+	return 0;
+}
+
+/*
+ * sys_iopl has to be used when you want to access the IO ports
+ * beyond the 0x3ff range: to get the full 65536 ports bitmapped
+ * you'd need 8kB of bitmaps/process, which is a bit excessive.
+ *
+ * Here we just change the flags value on the stack: we allow
+ * only the super-user to do it. This depends on the stack-layout
+ * on system-call entry - see also fork() and the signal handling
+ * code.
+ */
+long sys_iopl(unsigned int level, struct pt_regs *regs)
+{
+	unsigned int old = (regs->flags >> 12) & 3;
+	struct thread_struct *t = &current->thread;
+
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|iopl");
+
+	if (level > 3)
+		return -EINVAL;
+	/* Trying to gain more privileges? */
+	if (level > old) {
+		if (!capable(CAP_SYS_RAWIO))
+			return -EPERM;
+	}
+	regs->flags = (regs->flags & ~X86_EFLAGS_IOPL) | (level << 12);
+	t->iopl = level << 12;
+	set_iopl_mask(t->iopl);
+
+	return 0;
+}
diff -Naur linux-source-2.6.38.orig/kernel/itimer.c linux-source-2.6.38.modif/kernel/itimer.c
--- linux-source-2.6.38.orig/kernel/itimer.c	2011-03-15 02:20:32.000000000 +0100
+++ linux-source-2.6.38.modif/kernel/itimer.c	2011-12-16 14:06:25.000000000 +0100
@@ -105,6 +105,9 @@
 	int error = -EFAULT;
 	struct itimerval get_buffer;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|getitimer");
+
 	if (value) {
 		error = do_getitimer(which, &get_buffer);
 		if (!error &&
@@ -282,6 +285,9 @@
 	struct itimerval set_buffer, get_buffer;
 	int error;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|setitimer");
+
 	if (value) {
 		if(copy_from_user(&set_buffer, value, sizeof(set_buffer)))
 			return -EFAULT;
diff -Naur linux-source-2.6.38.orig/kernel/kexec.c linux-source-2.6.38.modif/kernel/kexec.c
--- linux-source-2.6.38.orig/kernel/kexec.c	2011-03-15 02:20:32.000000000 +0100
+++ linux-source-2.6.38.modif/kernel/kexec.c	2011-12-16 14:06:40.000000000 +0100
@@ -944,6 +944,9 @@
 	struct kimage **dest_image, *image;
 	int result;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|kexec_load");
+
 	/* We only trust the superuser with rebooting the system. */
 	if (!capable(CAP_SYS_BOOT))
 		return -EPERM;
diff -Naur linux-source-2.6.38.orig/kernel/ldt.c linux-source-2.6.38.modif/kernel/ldt.c
--- linux-source-2.6.38.orig/kernel/ldt.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-source-2.6.38.modif/kernel/ldt.c	2011-12-16 12:23:21.000000000 +0100
@@ -0,0 +1,271 @@
+/*
+ * Copyright (C) 1992 Krishna Balasubramanian and Linus Torvalds
+ * Copyright (C) 1999 Ingo Molnar <mingo@redhat.com>
+ * Copyright (C) 2002 Andi Kleen
+ *
+ * This handles calls from both 32bit and 64bit mode.
+ */
+
+#include <linux/errno.h>
+#include <linux/gfp.h>
+#include <linux/sched.h>
+#include <linux/string.h>
+#include <linux/mm.h>
+#include <linux/smp.h>
+#include <linux/vmalloc.h>
+#include <linux/uaccess.h>
+
+#include <asm/system.h>
+#include <asm/ldt.h>
+#include <asm/desc.h>
+#include <asm/mmu_context.h>
+#include <asm/syscalls.h>
+
+#ifdef CONFIG_SMP
+static void flush_ldt(void *current_mm)
+{
+	if (current->active_mm == current_mm)
+		load_LDT(&current->active_mm->context);
+}
+#endif
+
+static int alloc_ldt(mm_context_t *pc, int mincount, int reload)
+{
+	void *oldldt, *newldt;
+	int oldsize;
+
+	if (mincount <= pc->size)
+		return 0;
+	oldsize = pc->size;
+	mincount = (mincount + (PAGE_SIZE / LDT_ENTRY_SIZE - 1)) &
+			(~(PAGE_SIZE / LDT_ENTRY_SIZE - 1));
+	if (mincount * LDT_ENTRY_SIZE > PAGE_SIZE)
+		newldt = vmalloc(mincount * LDT_ENTRY_SIZE);
+	else
+		newldt = (void *)__get_free_page(GFP_KERNEL);
+
+	if (!newldt)
+		return -ENOMEM;
+
+	if (oldsize)
+		memcpy(newldt, pc->ldt, oldsize * LDT_ENTRY_SIZE);
+	oldldt = pc->ldt;
+	memset(newldt + oldsize * LDT_ENTRY_SIZE, 0,
+	       (mincount - oldsize) * LDT_ENTRY_SIZE);
+
+	paravirt_alloc_ldt(newldt, mincount);
+
+#ifdef CONFIG_X86_64
+	/* CHECKME: Do we really need this ? */
+	wmb();
+#endif
+	pc->ldt = newldt;
+	wmb();
+	pc->size = mincount;
+	wmb();
+
+	if (reload) {
+#ifdef CONFIG_SMP
+		preempt_disable();
+		load_LDT(pc);
+		if (!cpumask_equal(mm_cpumask(current->mm),
+				   cpumask_of(smp_processor_id())))
+			smp_call_function(flush_ldt, current->mm, 1);
+		preempt_enable();
+#else
+		load_LDT(pc);
+#endif
+	}
+	if (oldsize) {
+		paravirt_free_ldt(oldldt, oldsize);
+		if (oldsize * LDT_ENTRY_SIZE > PAGE_SIZE)
+			vfree(oldldt);
+		else
+			put_page(virt_to_page(oldldt));
+	}
+	return 0;
+}
+
+static inline int copy_ldt(mm_context_t *new, mm_context_t *old)
+{
+	int err = alloc_ldt(new, old->size, 0);
+	int i;
+
+	if (err < 0)
+		return err;
+
+	for (i = 0; i < old->size; i++)
+		write_ldt_entry(new->ldt, i, old->ldt + i * LDT_ENTRY_SIZE);
+	return 0;
+}
+
+/*
+ * we do not have to muck with descriptors here, that is
+ * done in switch_mm() as needed.
+ */
+int init_new_context(struct task_struct *tsk, struct mm_struct *mm)
+{
+	struct mm_struct *old_mm;
+	int retval = 0;
+
+	mutex_init(&mm->context.lock);
+	mm->context.size = 0;
+	old_mm = current->mm;
+	if (old_mm && old_mm->context.size > 0) {
+		mutex_lock(&old_mm->context.lock);
+		retval = copy_ldt(&mm->context, &old_mm->context);
+		mutex_unlock(&old_mm->context.lock);
+	}
+	return retval;
+}
+
+/*
+ * No need to lock the MM as we are the last user
+ *
+ * 64bit: Don't touch the LDT register - we're already in the next thread.
+ */
+void destroy_context(struct mm_struct *mm)
+{
+	if (mm->context.size) {
+#ifdef CONFIG_X86_32
+		/* CHECKME: Can this ever happen ? */
+		if (mm == current->active_mm)
+			clear_LDT();
+#endif
+		paravirt_free_ldt(mm->context.ldt, mm->context.size);
+		if (mm->context.size * LDT_ENTRY_SIZE > PAGE_SIZE)
+			vfree(mm->context.ldt);
+		else
+			put_page(virt_to_page(mm->context.ldt));
+		mm->context.size = 0;
+	}
+}
+
+static int read_ldt(void __user *ptr, unsigned long bytecount)
+{
+	int err;
+	unsigned long size;
+	struct mm_struct *mm = current->mm;
+
+	if (!mm->context.size)
+		return 0;
+	if (bytecount > LDT_ENTRY_SIZE * LDT_ENTRIES)
+		bytecount = LDT_ENTRY_SIZE * LDT_ENTRIES;
+
+	mutex_lock(&mm->context.lock);
+	size = mm->context.size * LDT_ENTRY_SIZE;
+	if (size > bytecount)
+		size = bytecount;
+
+	err = 0;
+	if (copy_to_user(ptr, mm->context.ldt, size))
+		err = -EFAULT;
+	mutex_unlock(&mm->context.lock);
+	if (err < 0)
+		goto error_return;
+	if (size != bytecount) {
+		/* zero-fill the rest */
+		if (clear_user(ptr + size, bytecount - size) != 0) {
+			err = -EFAULT;
+			goto error_return;
+		}
+	}
+	return bytecount;
+error_return:
+	return err;
+}
+
+static int read_default_ldt(void __user *ptr, unsigned long bytecount)
+{
+	/* CHECKME: Can we use _one_ random number ? */
+#ifdef CONFIG_X86_32
+	unsigned long size = 5 * sizeof(struct desc_struct);
+#else
+	unsigned long size = 128;
+#endif
+	if (bytecount > size)
+		bytecount = size;
+	if (clear_user(ptr, bytecount))
+		return -EFAULT;
+	return bytecount;
+}
+
+static int write_ldt(void __user *ptr, unsigned long bytecount, int oldmode)
+{
+	struct mm_struct *mm = current->mm;
+	struct desc_struct ldt;
+	int error;
+	struct user_desc ldt_info;
+
+	error = -EINVAL;
+	if (bytecount != sizeof(ldt_info))
+		goto out;
+	error = -EFAULT;
+	if (copy_from_user(&ldt_info, ptr, sizeof(ldt_info)))
+		goto out;
+
+	error = -EINVAL;
+	if (ldt_info.entry_number >= LDT_ENTRIES)
+		goto out;
+	if (ldt_info.contents == 3) {
+		if (oldmode)
+			goto out;
+		if (ldt_info.seg_not_present == 0)
+			goto out;
+	}
+
+	mutex_lock(&mm->context.lock);
+	if (ldt_info.entry_number >= mm->context.size) {
+		error = alloc_ldt(&current->mm->context,
+				  ldt_info.entry_number + 1, 1);
+		if (error < 0)
+			goto out_unlock;
+	}
+
+	/* Allow LDTs to be cleared by the user. */
+	if (ldt_info.base_addr == 0 && ldt_info.limit == 0) {
+		if (oldmode || LDT_empty(&ldt_info)) {
+			memset(&ldt, 0, sizeof(ldt));
+			goto install;
+		}
+	}
+
+	fill_ldt(&ldt, &ldt_info);
+	if (oldmode)
+		ldt.avl = 0;
+
+	/* Install the new entry ...  */
+install:
+	write_ldt_entry(mm->context.ldt, ldt_info.entry_number, &ldt);
+	error = 0;
+
+out_unlock:
+	mutex_unlock(&mm->context.lock);
+out:
+	return error;
+}
+
+asmlinkage int sys_modify_ldt(int func, void __user *ptr,
+			      unsigned long bytecount)
+{
+	int ret = -ENOSYS;
+
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|modify_ldt");
+
+	switch (func) {
+	case 0:
+		ret = read_ldt(ptr, bytecount);
+		break;
+	case 1:
+		ret = write_ldt(ptr, bytecount, 1);
+		break;
+	case 2:
+		ret = read_default_ldt(ptr, bytecount);
+		break;
+	case 0x11:
+		ret = write_ldt(ptr, bytecount, 0);
+		break;
+	}
+	return ret;
+}
diff -Naur linux-source-2.6.38.orig/kernel/module.c linux-source-2.6.38.modif/kernel/module.c
--- linux-source-2.6.38.orig/kernel/module.c	2011-09-28 16:24:41.000000000 +0200
+++ linux-source-2.6.38.modif/kernel/module.c	2011-12-16 14:11:35.000000000 +0100
@@ -755,6 +755,9 @@
 	char name[MODULE_NAME_LEN];
 	int ret, forced = 0;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|delete_module");
+
 	if (!capable(CAP_SYS_MODULE) || modules_disabled)
 		return -EPERM;
 
@@ -2864,6 +2867,9 @@
 	struct module *mod;
 	int ret = 0;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|init_module");
+
 	/* Must have permission */
 	if (!capable(CAP_SYS_MODULE) || modules_disabled)
 		return -EPERM;
diff -Naur linux-source-2.6.38.orig/kernel/perf_event.c linux-source-2.6.38.modif/kernel/perf_event.c
--- linux-source-2.6.38.orig/kernel/perf_event.c	2011-09-28 16:24:41.000000000 +0200
+++ linux-source-2.6.38.modif/kernel/perf_event.c	2011-12-16 14:12:12.000000000 +0100
@@ -5827,6 +5827,9 @@
 	int fput_needed = 0;
 	int err;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|perf_event_open");
+
 	/* for future expandability... */
 	if (flags & ~(PERF_FLAG_FD_NO_GROUP | PERF_FLAG_FD_OUTPUT))
 		return -EINVAL;
diff -Naur linux-source-2.6.38.orig/kernel/posix-timers.c linux-source-2.6.38.modif/kernel/posix-timers.c
--- linux-source-2.6.38.orig/kernel/posix-timers.c	2011-03-15 02:20:32.000000000 +0100
+++ linux-source-2.6.38.modif/kernel/posix-timers.c	2011-12-16 14:15:08.000000000 +0100
@@ -534,6 +534,9 @@
 	sigevent_t event;
 	int it_id_set = IT_ID_NOT_SET;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|timer_create");
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 
@@ -713,6 +716,9 @@
 	struct itimerspec cur_setting;
 	unsigned long flags;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|timer_gettime");
+
 	timr = lock_timer(timer_id, &flags);
 	if (!timr)
 		return -EINVAL;
@@ -742,6 +748,9 @@
 	int overrun;
 	unsigned long flags;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|timer_getoverrun");
+
 	timr = lock_timer(timer_id, &flags);
 	if (!timr)
 		return -EINVAL;
@@ -814,6 +823,9 @@
 	unsigned long flag;
 	struct itimerspec *rtn = old_setting ? &old_spec : NULL;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|timer_settime");
+
 	if (!new_setting)
 		return -EINVAL;
 
@@ -864,6 +876,9 @@
 	struct k_itimer *timer;
 	unsigned long flags;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|timer_delete");
+
 retry_delete:
 	timer = lock_timer(timer_id, &flags);
 	if (!timer)
@@ -950,6 +965,9 @@
 {
 	struct timespec new_tp;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|clock_settime");
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 	if (copy_from_user(&new_tp, tp, sizeof (*tp)))
@@ -964,6 +982,9 @@
 	struct timespec kernel_tp;
 	int error;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|clock_gettime");
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 	error = CLOCK_DISPATCH(which_clock, clock_get,
@@ -981,6 +1002,9 @@
 	struct timespec rtn_tp;
 	int error;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|clock_getres");
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 
@@ -1011,6 +1035,9 @@
 {
 	struct timespec t;
 
+	//GGuirado SysCall Statistics
+	printk(KERN_DEBUG "|clock_nanosleep");
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 
